// Cartoon.geom

// SetParameter GL_GEOMETRY_INPUT_TYPE_EXT=GL_TRIANGLES
// SetParameter GL_GEOMETRY_OUTPUT_TYPE_EXT=GL_TRIANGLES
// SetParameter GL_GEOMETRY_VERTICES_OUT_EXT=6

#version 130
#extension GL_EXT_geometry_shader4 : enable
#extension GL_EXT_gpu_shader4 : enable

// geometry shader of carttond shading

uniform float     boldness;

in vec3 positionIn[3];
in vec3 normalIn[3];
in vec4 GLSubPosition[3];

out float t;
out vec3 position;
out vec3 normal;

void main(void)
{
    for(int i = 0; i < gl_VerticesIn; i++){
	gl_TexCoord = gl_TexCoordIn[i];
	gl_Position = gl_PositionIn[i];
	t = 1;
	position = positionIn[i];
	normal = normalIn[i];
	EmitVertex();
    }
    EndPrimitive();

    if (boldness != 0){
	for(int i =  gl_VerticesIn-1; i >= 0; i--){
	    gl_Position = GLSubPosition[i];
	    t = 0;
	    EmitVertex();
	}
	EndPrimitive();
    }
}
