// PointSprite.vert

#version 130
#extension GL_EXT_gpu_shader4 : enable
#extension GL_ARB_explicit_attrib_location : enable

in float pointSize;
in int subIndex;

in vec3 tangent;
in vec3 binormal;

out vec3 positionIn;
out float pointSizeIn;
out int  subIndexIn;

out vec3 normalIn;
out vec3 tangentIn;
out vec3 binormalIn;

void main(void)
{
    gl_Position = /*gl_ModelViewProjectionMatrix *  */ gl_Vertex;
    
    vec3 normal = gl_Normal;
    normalIn = normal;
    tangentIn = tangent;
    binormalIn = cross(normal, tangent);
    
    gl_FrontColor = gl_Color;
    pointSizeIn = pointSize;
    positionIn = vec3(gl_ModelViewMatrix * gl_Vertex);
    subIndexIn = subIndex;
}
