// PointSprite.geom

// SetParameter GL_GEOMETRY_INPUT_TYPE_EXT=GL_POINTS
// SetParameter GL_GEOMETRY_OUTPUT_TYPE_EXT=GL_TRIANGLE_STRIP
// SetParameter GL_GEOMETRY_VERTICES_OUT_EXT=4

#version 130
#extension GL_EXT_geometry_shader4 : enable
#extension GL_EXT_gpu_shader4 : enable

uniform mat4 matrix;
uniform float length;
uniform int face;

in vec3 positionIn[1];
in float pointSizeIn[1];
out vec3 position;

void main(void){
    vec4 nX = gl_ModelViewProjectionMatrix * vec4(1, 0, 0, 0);
    vec4 nY = gl_ModelViewProjectionMatrix * vec4(0, 1, 0, 0);
    vec4 nZ = gl_ModelViewProjectionMatrix * vec4(0, 0, 1, 0);

    float psize = pointSizeIn[0];

    nX *= psize;
    nY *= psize;
    nZ *= psize;

    float factor = 3.14159 * 2 / face;

    for (int i = 0; i <= face; i++){
	gl_Position = gl_PositionIn[0] + 0.1*nX + cos(factor*i)*nY + sin(factor*i)*nZ;
	EmitVertex();
	gl_Position = gl_PositionIn[0] + length*nX + cos(factor*i)*nY + sin(factor*i)*nZ;
	EmitVertex();
    }

    EndPrimitive();

    gl_Position = gl_PositionIn[0] + 0.1*nX + nY;
    EmitVertex();
    for (int i = 1; i < face / 2; i++){
	gl_Position = gl_PositionIn[0] + 0.1*nX + cos(factor*i)*nY + sin(factor*i)*nZ;
	EmitVertex();
	gl_Position = gl_PositionIn[0] + 0.1*nX + cos(factor*(face-i))*nY + sin(factor*(face-i))*nZ;
	EmitVertex();
    }
    gl_Position = gl_PositionIn[0] + 0.1*nX - nY;
    EmitVertex();
    
    EndPrimitive();

    gl_Position = gl_PositionIn[0] + length*nX - nY;
    EmitVertex();
    for (int i = face / 2 - 1; i > 0; i--){
	gl_Position = gl_PositionIn[0] + length*nX + cos(factor*i)*nY + sin(factor*i)*nZ;
	EmitVertex();
	gl_Position = gl_PositionIn[0] + length*nX + cos(factor*(face-i))*nY + sin(factor*(face-i))*nZ;
	EmitVertex();
    }
    gl_Position = gl_PositionIn[0] + length*nX + nY;
    EmitVertex();
    
    EndPrimitive();
}
