// simple.vert

#version 130
#extension GL_EXT_gpu_shader4 : enable
#extension GL_ARB_explicit_attrib_location : enable

uniform int lightNumber;
uniform float scatter;

in float pointSize;
in int subIndex;

out vec3  positionIn;
out float pointSizeIn;
out int   subIndexIn;

out vec3 viewVecIn;
out vec3 normalIn;
out vec3 binormalIn;
out vec3 tangentIn;

void main(void)
{
    gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
    gl_FrontColor = gl_Color;
    gl_TexCoord[0] = gl_MultiTexCoord0;
    pointSizeIn = pointSize;
    positionIn = vec3(gl_ModelViewMatrix * gl_Vertex);
    subIndexIn = subIndex;

    vec3 position = vec3(gl_ModelViewMatrix * gl_Vertex);

    viewVecIn = -normalize(position);

    normalIn = vec3(0,0,1);
    binormalIn = vec3(0,1,0);
    tangentIn = vec3(1,0,0);
}

