// simple.vert

#version 130
#extension GL_EXT_gpu_shader4 : enable
#extension GL_ARB_explicit_attrib_location : enable

uniform int lightNumber;
uniform float scatter;

in float pointSize;
in int subIndex;

in vec3 tangent;
in vec3 binormal;

out vec3  positionIn;
out float pointSizeIn;
out int   subIndexIn;

out vec3 viewVecIn;
out vec3 normalIn;
out vec3 binormalIn;
out vec3 tangentIn;

void main(void)
{
    gl_Position = /*gl_ModelViewProjectionMatrix * */ gl_Vertex;
    gl_FrontColor = gl_Color;
    gl_TexCoord[0] = gl_MultiTexCoord0;
    vec3 position = vec3(gl_ModelViewMatrix * gl_Vertex);
    
    pointSizeIn = pointSize;
    positionIn = position;//vec3(gl_ModelViewMatrix * gl_Vertex);
    subIndexIn = subIndex;

    viewVecIn = -normalize(position);

    vec3 normal = gl_Normal;
    normalIn = normal;
    tangentIn = tangent;
    binormalIn = cross(normal, tangent);
}

